<?php

namespace Classes\Helper;

if (!defined('_PS_VERSION_')) {
    exit;
}

/**
 * Base Class for methods associated with error handling
 *
 * @class    ErrorHandling
 * @version  1.0.2
 * @package  zipMoney Payments
 * @author   zipMoney Payments
 */
class ErrorHandling
{

    public static function getMappedErrorCode($code)
    {
        $mapped = array(
            "account_insufficient_funds" => "PS-0001",
            "account_inoperative" => "PS-0002",
            "account_locked" => "PS-0003",
            "amount_invalid" => "PS-0004",
            "fraud_check" => "PS-0005",
            "invalid_state" => "PS-0006",
        );
        if (array_key_exists($code, $mapped)) {
            return $mapped[$code];
        }
        return;
    }
}
