<?php

namespace Classes;

if (!defined('_PS_VERSION_')) {
    exit;
}

/**
 * Class for widgets and banners rendering
 *
 * @class    zipMoneyWidgets
 * @version  1.0.2
 * @package  zipMoney Payments
 * @author   zipMoney Payments
 */
class zipMoneyWidgets extends zipMoney
{
    public $context = null;

    public function __construct($context)
    {
        $this->context = $context;
    }

    /**
     * Renders the banner
     *
     * @access public
     * @return html
     */
    public function renderBanner()
    {
        return $this->fetch('module:zipmoneypayment/views/templates/hooks/banner.tpl');
    }

    /**
     * Renders the banner in the category page.
     *
     * @access public
     * @return html
     */
    public function fetch($templatePath, $cache_id = null, $compile_id = null)
    {
        if ($cache_id !== null) {
            \Tools::enableCache();
        }

        if (version_compare(_PS_VERSION_, '1.7', '<')) {
            list(, $template)  = explode(":", $templatePath);
            $templatePath  = 'modules/' . $template;
        }

        $template = $this->context->smarty->createTemplate(
            $templatePath,
            $cache_id,
            $compile_id,
            $this->context->smarty
        );

        if ($cache_id !== null) {
            \Tools::restoreCacheSettings();
        }

        return $template->fetch();
    }

    /**
     * Renders the widget below add to cart / proceed to checkout button in product or cart pages.
     *
     * @access public
     * @return html
     */
    public function renderWidgetCart()
    {
        return $this->fetch('module:zipmoneypayment/views/templates/hooks/cart_widget.tpl');
    }

    /**
     * Renders the widget below add to cart / proceed to checkout button in product or cart pages.
     *
     * @access public
     * @return html
     */
    public function renderWidgetProduct()
    {
        return $this->fetch('module:zipmoneypayment/views/templates/hooks/product_widget.tpl');
    }
}
