<?php
require(dirname(__FILE__) . '/../../config/config.inc.php');

define("PS_MOD", "zipmoneypayment");

try {
    $module = Module::getInstanceByName(urldecode(PS_MOD));

    if (!method_exists($module, 'install')) {
        throw new PrestaShopException('Method of module cannot be found');
    }

    $module->uninstall();

    // Get the return value of current method
    if ($module->install()) {
        Configuration::updateValue('ZM_IS_ACTIVE', true);
        Configuration::updateValue('ZM_IS_PRODUCTION', true);
        Configuration::updateValue('ZM_IN_CONTEXT', true);

        Configuration::updateValue('ZM_DISPLAY_WIDGET_PRODUCTPAGE', true);
        Configuration::updateValue('ZM_DISPLAY_WIDGET_CARTPAGE', true);

        Configuration::updateValue('ZM_DISPLAY_BANNER_HOMEPAGE', true);
        Configuration::updateValue('ZM_DISPLAY_BANNER_CATEGORYPAGE', true);
        Configuration::updateValue('ZM_DISPLAY_BANNER_PRODUCTPAGE', true);
        Configuration::updateValue('ZM_DISPLAY_BANNER_CARTPAGE', true);

        Configuration::updateValue('ZM_DISPLAY_TAGLINE_PRODUCTPAGE', true);
        Configuration::updateValue('ZM_DISPLAY_TAGLINE_CARTPAGE', true);

        echo "\r\n===Module Installed Successfully===\r\n";
    } else {
        throw new PrestaShopException("Module couldn't be installed", 1);
    }
} catch (\Exception $e) {
    echo "\r\n===Following Errors Occurred===\r\n" . $e->getMessage() . "\r\n\r\n";
}
