<?php

use Classes\Helper\Sdk;

/**
 * @class    ZipmoneyPaymentPaymentModuleFrontControllerTest
 * @version  1.0.2
 * @package  zipMoney Payments
 * @author   zipMoney Payments
 */
class ZipmoneyPaymentPaymentModuleFrontControllerTest extends ModulePrestaShopPHPUnit
{
    public $module = null;

    /**
     * Test Module setting up payment route
     *
     * @access public
     */
    public function setUp()
    {
        require_once dirname(__FILE__) . "/../../../controllers/front/payment.php";

        $this->module = \Module::getInstanceByName(Tools::strtolower('zipmoneypayment'));

        $_POST['module'] = 'zipmoneypayment';

        $this->context = \Context::getContext();

        $this->controller = \Controller::getController("ZipmoneyPaymentPaymentModuleFrontController");
        $this->controller->module = $this->module;
    }

    /**
     * Test Module for payment inititation in payment route
     *
     * @access public
     */
    public function testPaymentInit()
    {

        $cart = $this->getMockBuilder('Cart')
            ->setConstructorArgs(array(2))
            ->getMock();

        $cart->method('getOrderTotal')
            ->willReturn(55);

        $checkoutApi = $this->getMockBuilder(Sdk::CHECKOUT_API_CLASS)->getMock();
        $testOut = new \zipMoney\Model\Checkout();
        $testOut->setUri("http://google.com.au");
        $checkoutApi->method('checkoutsCreate')->willReturn($testOut);

        $this->controller->setCart($cart);

        Sdk::setApi(Sdk::CHECKOUT_API_CLASS, $checkoutApi);

        $this->controller->init();
        $redirect_url = $this->controller->paymentInit();

        // echo "Redirect Url: " . $redirect_url;

        $this->assertEquals("http://google.com.au", $redirect_url);
    }
}
